# CreateScenarioWindow Struct Reference

Inheritance diagram for CreateScenarioWindow:

## Public Member Functions
| CreateScenarioWindow (const WindowDesc *desc, WindowNumber window_number)
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | OnPaint ()
| The window must be repainted.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnTimeout ()
| Called when this window's timeout has been reached.
virtual void | OnDropdownSelect (int widget, int index)
| A dropdown option associated to this window has been selected.
virtual void | OnQueryTextFinished (char *str)
| The query window opened from this window has closed.
## Data Fields
uint | widget_id

## Detailed Description

Definition at line 852 of file genworld_gui.cpp.

## Member Function Documentation

virtual void CreateScenarioWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 924 of file genworld_gui.cpp.

References _left_button_clicked, _settings_newgame, Clamp(), CS_NUMERAL, CSCEN_ARCTIC, CSCEN_EMPTY_WORLD, CSCEN_FLAT_LAND_HEIGHT_DOWN, CSCEN_FLAT_LAND_HEIGHT_TEXT, CSCEN_FLAT_LAND_HEIGHT_UP, CSCEN_MAPSIZE_X_PULLDOWN, CSCEN_MAPSIZE_Y_PULLDOWN, CSCEN_RANDOM_WORLD, CSCEN_START_DATE_DOWN, CSCEN_START_DATE_TEXT, CSCEN_START_DATE_UP, CSCEN_TEMPERATE, CSCEN_TOYLAND, CSCEN_TROPICAL, Window::flags4, GameSettings::game_creation, GLWM_SCENARIO, Window::HandleButtonClick(), GameCreationSettings::landscape, GameCreationSettings::map_x, GameCreationSettings::map_y, MAX_TILE_HEIGHT, MAX_YEAR, MIN_YEAR, Window::RaiseWidget(), GameCreationSettings::se_flat_world_height, Window::SetDirty(), SetDParam(), SetNewLandscapeType(), ShowDropDownList(), ShowQueryString(), GameCreationSettings::starting_year, WF_TIMEOUT_MASK, and WF_TIMEOUT_TRIGGER.

virtual void CreateScenarioWindow::OnDropdownSelect | ( | int | widget,
|  | int | index |
| ) |  |  | `[inline, virtual]`

A dropdown option associated to this window has been selected.

Parameters:

  | widget | the widget (button) that the dropdown is associated with.
  | index | the element in the dropdown that is selected.

Reimplemented from Window.

Definition at line 1000 of file genworld_gui.cpp.

References _settings_newgame, CSCEN_MAPSIZE_X_PULLDOWN, CSCEN_MAPSIZE_Y_PULLDOWN, GameSettings::game_creation, GameCreationSettings::map_x, GameCreationSettings::map_y, and Window::SetDirty().

virtual void CreateScenarioWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 883 of file genworld_gui.cpp.

References _settings_newgame, CSCEN_ARCTIC, CSCEN_FLAT_LAND_HEIGHT_DOWN, CSCEN_FLAT_LAND_HEIGHT_UP, CSCEN_START_DATE_DOWN, CSCEN_START_DATE_UP, CSCEN_TEMPERATE, CSCEN_TOYLAND, CSCEN_TROPICAL, Window::DrawWidgets(), GameSettings::game_creation, GameCreationSettings::landscape, MAX_TILE_HEIGHT, MAX_YEAR, MIN_YEAR, GameCreationSettings::se_flat_world_height, Window::SetWidgetDisabledState(), Window::SetWidgetLoweredState(), and GameCreationSettings::starting_year.

virtual void CreateScenarioWindow::OnQueryTextFinished | ( | char * | str | ) | `[inline, virtual]`

The query window opened from this window has closed.

Parameters:

  | str | the new value of the string, NULL if the window was cancelled or an empty string when the default button was pressed, i.e. StrEmpty(str).

Reimplemented from Window.

Definition at line 1009 of file genworld_gui.cpp.

References _settings_newgame, Clamp(), CSCEN_FLAT_LAND_HEIGHT_TEXT, CSCEN_START_DATE_TEXT, GameSettings::game_creation, MAX_TILE_HEIGHT, MAX_YEAR, MIN_YEAR, GameCreationSettings::se_flat_world_height, Window::SetDirty(), Window::SetWidgetDirty(), GameCreationSettings::starting_year, and StrEmpty().

virtual void CreateScenarioWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 862 of file genworld_gui.cpp.

References _settings_newgame, ConvertYMDToDate(), CSCEN_FLAT_LAND_HEIGHT_TEXT, CSCEN_MAPSIZE_X_PULLDOWN, CSCEN_MAPSIZE_Y_PULLDOWN, CSCEN_START_DATE_TEXT, GameSettings::game_creation, GameCreationSettings::map_x, GameCreationSettings::map_y, GameCreationSettings::se_flat_world_height, SetDParam(), and GameCreationSettings::starting_year.

virtual void CreateScenarioWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 898 of file genworld_gui.cpp.

References ConvertYMDToDate(), CSCEN_FLAT_LAND_HEIGHT_TEXT, CSCEN_MAPSIZE_X_PULLDOWN, CSCEN_MAPSIZE_Y_PULLDOWN, CSCEN_START_DATE_TEXT, GetStringBoundingBox(), MAX_MAP_SIZE, MAX_TILE_HEIGHT, MAX_YEAR, and SetDParam().

The documentation for this struct was generated from the following file:

- src/genworld_gui.cpp